1 '
2 '*****************************************************************************
3 ' 			VIDEOJUEGO ESTILO SIMON - v1.0 - Nov2020
4 ' 			    (c) 1986-2020 - ENRIQUE BUZON
8 '- Compilar: ./make.sh && cpct_winape -a
9 '*****************************************************************************
1 '
1 '
1 ';-------------------------------------------------------------------- 
1 '; NUEVOS COMANDOS RSX PARA BASIC:
1 '; |GRSETPEN,n -> color a establecer en la pluma gráfica. Similar a GRAPHICS PEN de 664/6128
1 '; |FLUSH,n ->buffer = Vacía el bufer de Teclado si el param. es 0; el de Sonido si el parámetro es 1 
1 '; * Si Empieza en &8000, ocupa hasta &8148, Long=&148=328bytes
1 '; --------------------------------------------------------------------

1 ' *********************************************************************
1 '                             INICIALIZAR
1 ' *********************************************************************
10 SYMBOL AFTER 47
15 h=HIMEM+1
20 LOAD"spaceage.fnt",h
1  'Basic por debajo de &6000 y 4KB de buffer de disco (&1000) 
30 MEMORY &5FFF
40 LOAD"simonbin.bin",&6000
45 LOAD"simbufer.bin",&C000
1 'Basic debajo buffer disco 4096 Bytes, una vez terminada op. carga, usar area &5000-5FFF para BIN2 (Música y algunos Sprites)
47 OPENOUT "Dummy":MEMORY HIMEM-1:CLOSEOUT

50 DEFINT a-z:RANDOMIZE TIME:main=&930E
1 'Activar acceso Main y RSX solo 1 vez
60 IF flagrsx=0 THEN CALL main:flagrsx=1

1 'Inicializar la Secuencia de pulsaciones del Computador y del Player
70 DIM compsec(99):DIM playersec(99)

1 ';*********************************************************************
1 ';                 FUNCIONES ASM HECHAS CON CPCTELERA
1 ';*********************************************************************
1 '; Simonbin.bin
1 '; &4000 - MÚSICA
1 '; &74EB - Main para llamar a los RSX 
1 '; &74EF _pintar_spr_display (con rótulo CPC y 2 dígitos apagado)
1 '; &7505 _pintar_spr_num_display -> POSIC%=0:DIG%=8:CALL &7505, @POSIC%, @DIG%
1 '; &75A0 _pintar_spr_you
1 '; &75B6 _pintar_spr_simon: insertar 4 sprites del Simon
1 '; &760B _pintar_spr_pressanykey
1 '; &7621  _pintar_spr_youwin
1 '; &7637  _pintar_spr_gameover
1 '; &7657 _extraer_FKCs
1 '; &7662 _escanear_teclado y depositar la tecla pulsada en teclaPulsada 
1 '; &8179 - tecla-pulsada  
1 '; &817B -TeclaArribaHb:High Byte de la Constante ASM del teclado, para la tecla Redefinida por usuario como "Arriba".
1 '; &817E -TeclaAbajoHb: igual que la anterior, pero tecla "Abajo". El Low Byte cambia el sufijo Hb por Lb.
1 '; &8181 -TeclaIzqHb y TeclaDerHb y Lb, igual que lo anterior.
1 '--FKCup /FKCdw /FKCiz /FKCder: Contienen direcciones RAM grabar Firmware Keyboard Code: código de teclado (0-79) 
1 '--fkcu, fkcd, fkcl, fkcr: Contienen el valor n del FKC código de teclado (0-79)			    
1 '; * Microhobby Amstrad Semanal 099 			                	    
1 '; |FLUSH -comando extra para vaciado de buferes de teclado o sonido. 0 KM READ CHAR. 1 SOUND RESET. 
1 '; --------------------------------------------------------------------

75 escanearTeclado=&9315: leerTeclaRedef=&937F: rutinaPulsada=&93BC: extraerFKCs=&9420
80 pintarSprDisplay=&9469: pintarSprNumDisplay=&947F: pintarSprYou=&951A
85 pintarSprSimon=&9530: pintarSprPressanykey=&9585: pintarSprYouwin=&959B
90 pintarSprGameover=&95B1: pintarSprNextLevel=&95C7: pintarSprMarcomenus=&968D 

93 pintSprCandelf1Iz=&95F3: pintSprCandelf2Iz=&9609: pintSprCandelf3Iz=&961F
95 pintSprCandelBaseDer=&9635: pintSprCandelf1Der=&964B: pintSprCandelf2Der=&9661  
97 pintSprCandelf3Der=&9677: pintSprCandelBaseIz=&95DD

100 teclaPulsada=&99AA: teclaPulChar=&99AB: contadorFKC=&99AC: valorArray=&99AD: teclaRedef=&99AF                        

110 TeclaArribaHb=&98F2: TeclaArribaLb=TeclaArribaHb+1: FKCup=TeclaArribaLb+1
120 TeclaAbajoHb=&98F5: TeclaAbajoLb=TeclaAbajoHb+1: FKCdw=TeclaAbajoLb+1
130 TeclaIzqHb=&98F8: TeclaIzqLb=TeclaIzqHb+1: FKCiz=TeclaIzqLb+1 
140 TeclaDerHb=&98FB: TeclaDerLb=TeclaDerHb+1: FKCder=TeclaDerLb+1

150 TeclaRepHb=&98FE: TeclaRepLb=TeclaRepHb+1: FKCTecRepe=TeclaRepLb+1
160 TeclaMoreHb=&9901: TeclaMoreLb=TeclaMoreHb+1: FKCTecMore=TeclaMoreLb+1

1 ' Las siguientes 3 direcciones son de SimonBufer.BIN
165 InitMusic=&5753: PlayMusic=&575A: StopMusic=&576C

1 '****************************************************************************************************************
1 '                         DECLARACION DE VARIABLES
1 '****************************************************************************************************************
1 '--compsec: matriz que almacena los números de la secuencia generada por el ordenador (1-4)
1 '--playersec: secuencia respondida por el jugador (1-4)
1 '--p: Índice de Pulsación de la Secuencia de la partida, almacenadas en Matriz del Player como de la Computadora
1 '--nivel: indica secuencia máxima según Nivel (1-4) elegido por usuario
1 '--x: nuevo número aleatorio generado
1 '--contador: contador total de elementos de la secuencia aleatoria
1 '--flagerror: indica si el jugador ha cometido error en su secuencia
1 '--flagrsx: indica si se ha arrancado ya la rutina RSX Mode1 y Borrar bufer. No puede llamarse 2 veces. 0=no 1=si
1 '--flaglev: tecla levantada. 1 cuando se ha escaneado y no hay tecla pulsada, 0 cuando proceso 1 tecla
1 '--flagtemp: flag temporizador. Si ya había acabado vale 0, si esta funcionando aun vale 1
1 '--controlflag: flag que determina si el control es con teclado o joystick (0-1)
1 '--mTeclado$(79): Matriz constantes ASM del teclado. las 0-79 (ID) teclas se corresponden con su código 2 bytes
1 '--flagfinpartida: flag que indica si se acaba de finalizar una partida, para pedir nombre en Tabla Puntuaciones
1 '--flagtablapunt: flag que indica si la Tabla de Puntuaciones ha sido cargada en la matriz, ordenada (inicializada)
1 '--flagnext: a 1 indica que la tecla L ha sido pulsada al terminar un nivel
1 '--flagPlayMusic: a 1 indica que la música se está reproduciendo, el temporizador 3 está accediendo cada 0,02seg
1 '--flagMusic: a 1 indica que sí quiero música en los menús
1 '--flagRepetir=1 indica que he pulsado la tecla Repetir 
1 '--flagRotacion: indica si no se ha pulsado una tecla en el Menú y se inicia rotación de pantallas
1 '--------------------------------------------------------------------
170 nivel=0:a=0:a$="":x=0:contador=0:temp=0:flagcpu=0:flagerror=0:flagMusic=1:flagPlayMusic=0
180 flaglev=0:flagtemp=0:p=0:controlflag=0:flagfinpartida=0:flagtablapunt=0:flagRedefTeclado=0
185 flagRepetir=0

190 DIM mTeclado$(79)


1 '****************************************
1 '                 MAIN                  
1 '****************************************

1 'Reinicializar    
200 GOSUB 10100:|FLUSH, 0
1 ' Redefinir Cursores por defecto, si no se redefinieron teclas anteriormente
205 IF flagRedefTeclado=0 THEN GOSUB 10600

1 ' Mostrar Menu 8000
210 GOSUB 8000 
215 IF flagRotacion=1 THEN GOSUB 350

1 'Mostrar Pantalla Simon, y Espera una tecla para empezar a jugar
220 GOSUB 1200 

1 'JUEGA COMPUTER, previo Retardo 500mseg
230 GOSUB 9000:GOSUB 400

1 'JUEGA PLAYER, reinicializando su secuencia de respuesta
240 |FLUSH, 0:ERASE playersec:DIM playersec(99):GOSUB 600
245 IF flagRepetir=1 THEN flagRepetir=0:GOTO 240

1 'MOSTRAR FALLO si no ganaste y finalizar Main
250 IF flagerror=1 THEN GOSUB 2000:flagfinpartida=1:GOTO 280 

1 'Si Gana Player ir 7500, SI NO, Continuar Juega Computer en 400
260 IF nivel=contador AND flagnext=0 THEN GOSUB 7500:flagfinpartida=1:ELSE GOTO 230
270 IF flagnext=1 THEN flagnext=0:flagfinpartida=0:GOTO 230

1 'Mostrar Tabla de Puntuaciones
280 IF flagfinpartida=1 THEN GOSUB 5000
1 'Activar recolector de basura manualmente
290 basura=UNT(FRE(""))
1 'Reiniciar Main
300 GOTO 200

1'************ Activar Rotación de Menús, Créditos, Tablero Puntos, Demo ***************
1 'rotacion: var que almacena pantalla que se va rotando. 3500->1=Créditos // 5000->2=Tabla Punt. // 8000->3=Menú // 3000->4=Demo
350 rotacion=rotacion+1:|FLUSH,0 
360 IF rotacion<1 OR rotacion>4 THEN rotacion=1
365 ON rotacion GOSUB 3500, 5000, 8000, 3000
368 IF flagrotacion=1 then 350
370 RETURN



1 '*************************************************************************
1 '                    SECUENCIA PARTIDA Computer  
1 '*************************************************************************
1 'Crear nuevo elemento de la secuencia
400 x=INT(RND(-TIME)*4)+1:contador=contador+1
1 'Agregar Nuevo Número a la MATRIZ Secuencia Computadora'
410 compsec(contador)=x
1 'Imprimir contador de la Secuencia en curso (display)
420 GOSUB 9500
430 FOR p=1 TO contador
425 EVERY 15,1 GOSUB 1400
1 'retardo 150mseg entre notas
440 GOSUB 9100
1 'temporizador activado para cancelar sonido y restaurar tintas tras 0.5seg (Borrado)
450 flagtemp=1 
460 AFTER 25,0 GOSUB 9300
1 'encendido teclas y sonidos (1-4) correspondiente a la Pulsación de la secuencia generada por Computer
470 ON compsec(p) GOSUB 7000,7100,7200,7300 
1 'pararse aqui hasta terminar el After de borrado completamente, flagtemp=0
480 WHILE flagtemp=1:WEND:' IF flagtemp=1 THEN 480 
490 NEXT
500 RETURN


1 '*************************************************************************
1 '                  SECUENCIA Player: RUTINA TECLADO 
1 '*************************************************************************
1 ' Completar secuencia desde la 1ª Pulsación hasta la última del CPC
600 p=1
1 'Pintar YOU -> sprite _pintar_spr_you
620 CALL pintarSprYou:flagcinco=0

1 'Margen de 5seg=250 6=300 para pulsar un botón o dará error
1 'Activar temporizador Nº1 (de 0-4) para dejar de escanear teclado tras 5" y provocar error del Player
625 AFTER 300,1 GOSUB 900

1 'Extraer 1 o 2 teclas válidas
630 WHILE 1

1 'ASM comprobar tecla Pulsada o Levantada y almacenar en teclaPulsada 
640 CALL escanearTeclado
1' ERROR por tiempo. Se terminaron los 5" Sonido de error grave. Flag y salir de la secuencia.
645 IF flagcinco=1 THEN GOSUB 9000:GOSUB 9000:SOUND 1,600,100,15:flagerror=1:GOTO 820
1 'recoger la tecla detectada por rutina en CM 
650 tecla=PEEK(teclaPulsada)
1 'Levantado, volver a escanear teclas 
660 IF tecla=255 THEN flaglev=1:GOTO 790 
1 'Si temporizador estaba funcionando, AND había tecla pulsada (y levantada), apagarlo y restaurar tintas y sonido
670 IF flagtemp=1 AND flaglev=1 THEN temp=REMAIN(0):GOSUB 9300

1 'Tecla pulsada, procesarla: meterla en MATRIZ Secuencia Player, tocarla y flaglev=0
675 IF tecla=fkcrep AND flaglev=1 AND p=1 THEN GOSUB 420:flagRepetir=1:GOTO 820
680 IF tecla=fkcd AND flaglev=1 THEN temp=REMAIN(1):playersec(p)=1:p=p+1:GOSUB 7000:flaglev=0:'Pulsacion 1=Azul
690 IF tecla=fkcr AND flaglev=1 THEN temp=REMAIN(1):playersec(p)=2:p=p+1:GOSUB 7100:flaglev=0:'Pulsacion 3=Amarillo
700 IF tecla=fkcl AND flaglev=1 THEN temp=REMAIN(1):playersec(p)=3:p=p+1:GOSUB 7200:flaglev=0:'Pulsacion 4=Verde
710 IF tecla=fkcu AND flaglev=1 THEN temp=REMAIN(1):playersec(p)=4:p=p+1:GOSUB 7300:flaglev=0:'Pulsacion 6=Rojo

1 'activar temporizador de Borrado, 25=0.5" pero continuar escaneando teclado con While
740 flagtemp=1 
750 AFTER 25,0 GOSUB 9300
1 'borra ultima tecla detectada por CM, y ya procesada
760 POKE teclaPulsada,&FF 

1 'COMPROBAR tecla pulsada actual con la secuencia de computer
1 'Si la tecla es erronea, esperar 1". Sonido de error grave. Flag y salir de la secuencia.
770 IF compsec(p-1)<>playersec(p-1) THEN GOSUB 9000:GOSUB 9000:SOUND 1,600,100,15:flagerror=1:GOTO 820
1 ' Si la Tecla es válida, salir del WHILE, y a por otra tecla
780 IF compsec(p)=playersec(p) THEN 800
1 'Fin del While extracción de teclas
790 WEND 

1 'While repetir Secuencia CPC, no funciona anidado
800 IF p<contador THEN 620
1 'frenar hasta que el temporizador Nº0 de borrado acabe y se ponga flagtemp a 0 
810 IF flagtemp=1 THEN 810 
820 RETURN

1 'AFTER: Se cumplieron los 5", por tanto error en la secuencia del Player, Game Over
900 flagcinco=1
910 RETURN



1 '*************************************************************************
1 '                      MOSTRAR PANTALLA SIMON 
1 '*************************************************************************
1 ' Pintar SIMON 4 Sprites, RSX 6colores en Mode 1. 
1200 '
1205 MODE 0
1210 INK 0,0:INK 1,1:INK 2,2:INK 3,3:INK 4,4:INK 5,6
1215 INK 6,9:INK 7,10:INK 8,11:INK 9,12:INK 10,13:INK 11,15
1216 INK 12,18:INK 13,22:INK 14,24:INK 15,26

1 'pinta estrellas
1220 FOR e=1 TO 250
1221 x=RND*639:y=RND*399:t=RND*3
1222 if t=0 then tinta=1
1223 if t=1 then tinta=4
1224 if t=2 then tinta=15
1225 if t=3 then tinta=10
1226 PLOT x,y,tinta
1227 NEXT

1 '_pintar_simon. Muestra los 4 sprites del simon 
1230 CALL pintarSprSimon

1 'pinta suelo
1235 ORIGIN 0,0:ink 1,1:|GRSETPEN,13
1 'Primera linea hor inferior
1240 MOVE 0,15:DRAW 248,15:MOVE 395,15:DRAW 639,15 
1242 MOVE 639,29:DRAW 425,29:MOVE 222,29:DRAW 0,29
1244 MOVE 0,43:DRAW 196,43:MOVE 447,43:DRAW 639,43
1246 MOVE 639,57:DRAW 465,57:MOVE 180,57:DRAW 0,57
1248 MOVE 0,70:DRAW 166,70:MOVE 476,70:DRAW 639,70
1250 MOVE 639,84:DRAW 488,84:MOVE 157,84:DRAW 0,84
1252 MOVE 0,94:DRAW 152,94:MOVE 495,94:DRAW 639,94
1254 MOVE 147,101:DRAW 0,101:MOVE 497,101:DRAW 639,101
1 'Primera linea hor superior
1255 MOVE 0,104:DRAW 145,104:MOVE 499,104:DRAW 639,104
1 'central vert
1256 MOVE 320,0:DRAW 320,2 
1257 MOVE 400,0:DRAW 396,15
1258 MOVE 480,0:DRAW 446,43
1259 MOVE 560,0:DRAW 477,74 
1 'ultima vert der cortada
1260 MOVE 640,0:DRAW 494,98 
1261 MOVE 720,0:DRAW 520,104
1262 MOVE 800,0:DRAW 560,104
1263 MOVE 880,0:DRAW 600,104
1264 MOVE 240,0:DRAW 247,17
1265 MOVE 160,0:DRAW 198,43
1266 MOVE 80,0:DRAW 164,74
1267 MOVE 0,0:DRAW 149,95 
1268 MOVE -80,0:DRAW 120,104
1269 MOVE -160,0:DRAW 80,104
1270 MOVE -240,0:DRAW 40,104

1280 call pintSprCandelBaseIz: call pintSprCandelf1Iz
1290 call pintSprCandelBaseDer: call pintSprCandelf2Der

1295 EVERY 15,0 GOSUB 1400
1 'pinta _spr_display apagado
1300 CALL pintarSprDisplay 
1 ' 760B _pintar_spr_pressanykey
1310 CALL pintarSprPressanykey
1320 IF flagRotacion=1 THEN 1340 
1330 WHILE INKEY$="":WEND
1340 temp=REMAIN(0)
1350 RETURN

1 'cambiar la flama de la animación del candelabro
1400 ani=ani+1: IF ani>=3 THEN ani=0
1410 IF ani=0 THEN CALL pintSprCandelf1Iz: CALL pintSprCandelf3Der
1420 IF ani=1 THEN CALL pintSprCandelf2Iz: CALL pintSprCandelf1Der
1430 IF ani=2 THEN CALL pintSprCandelf3Iz: CALL pintSprCandelf2Der
1440 RETURN



1 '******************** MOSTRAR FALLO *********************
2000 CALL pintarSprGameover 
2020 |FLUSH,0
1 ' Retardo 0.500 mseg.  Restaurar tintas. Encender botón correcto con intermitencia. Esperar tecla y R.
2025 IF p=1 THEN p=2
2030 GOSUB 9000: GOSUB 9300:ON compsec(p-1) GOSUB 7400,7410,7420,7430
2040 CALL &BB18
2050 IF INKEY(50)=0 THEN GOSUB 420:GOTO 2000
2100 RETURN


1 '******************************************** 
1 '             PANTALLA DEMO 
1 '********************************************
1 'mostrar pantalla del simon
3000 GOSUB 1200
3010 FOR contador=99 TO 0 STEP -1
1 'Imprimir display: secuencia de números actual del Contador
3020 GOSUB 9500
1' retardo 0,180
3030 GOSUB 9100
3040 NEXT 
3050 contador=0:t1!=TIME
3060 a$=INKEY$
3070 t2!=TIME:totalTime=(t2!-t1!)/300:IF totalTime>5 THEN 3100
3080 IF a$="" THEN 3060
3100 RETURN 

 
1 '**********************************************
1 '           PANTALLA DE CRÉDITOS                   
1 '**********************************************
1 '****************** Efecto Teletipo  ****************************
1 '3500 MODE 1:BORDER 0:INK 0,0:INK 1,1:INK 2,2:INK 3,11:PEN 3
3500 MODE 1:BORDER 0:INK 0,0:INK 1,9:INK 2,18:INK 3,22:PEN 3
1 ''StopMusic o Pausa apagando Every
3505 IF (flagMusic=1 AND flagPlayMusic=1) THEN flagPlayMusic=0:GOSUB 10970
3510 CALL pintarSprMarcomenus
1 ''PlayMusic sin rebobinar, sigue reproduciendo 
3515 IF (flagMusic=1 AND flagPlayMusic=0) THEN flagPlayMusic=1:GOSUB 10910

1 'Tamaño de ventana: izquierdo, derecho, superior e inferior 
3520 WINDOW #1,10,32,5,23:RESTORE 3690
3570 FOR g=1 TO 6
3580 READ a$
3590 FOR h=1 TO LEN(a$)
3595 b$=INKEY$:IF b$<>"" THEN 3800
1 'los sonidos corrompen la música, saltarlos si está activada
3597 IF flagMusic=1 THEN 3630
3600 SOUND 1,ASC(MID$(a$,h,1))*15,5,12
3610 SOUND 4,ASC(MID$(a$,h,1))*15+3,5,12
3620 SOUND 2,956,5,10,0,0,1
1 'imprimir letra por letra en Pen 3=11 Sky blue. Imprimir el cursor (143) en Pen 2=Bright Blue.
3630 PEN #1,3:PRINT #1,MID$(a$,h,1);:PEN #1,2:PRINT #1,CHR$(143);
1 'retardo de 50mseg, borrar el cursor (8)
3640 FOR z=1 TO 90:NEXT z:PRINT #1,CHR$(8);  
3650 NEXT h
3660 FOR z=1 TO 500:NEXT z:PRINT #1," ":PRINT #1
3670 NEXT G 
3690 DATA "       CREDITS                -------","CODE: ENRIQUE BUZON","MUSIC: TARGHAN"
3700 DATA "GRAPHICS:ENRIQUE BUZON","MADE WITH: LOCOMOTIVE  BASIC, Z80 ASSEMBLER & CPCTELERA"
3710 DATA "SPAIN - 2020"
1 'Retardo 5seg para Rotación de pantallas o si se pulsa tecla
3740 t1!=TIME 
3750 a$=INKEY$
3780 t2!=TIME:totalTime=(t2!-t1!)/300:IF totalTime>5 THEN 3800
3790 IF a$="" THEN 3750
3800 RETURN 



1 ' ***************** INICIALIZAR TABLA DE PUNTUACIONES (desde Menú) **************
4000 flagtablapunt=1:n=16
1 ''cargar datos desde DATAs en matriz solo 1 vez.
4010 IF flagdatas=0 THEN GOSUB 5510  
1 'ordenacion de la matriz por burbuja
4020 GOSUB 5580
4030 RETURN


1 '**********************************************
1 '*       PANTALLA TABLA DE PUNTUACIONES                   
1 '**********************************************
5000 MODE 1:BORDER 0:INK 0,0:INK 1,1:INK 2,2:INK 3,11:PEN 3:n=16
1 ''cargar datos desde DATAs en matriz solo 1 vez.
5100 IF flagdatas=0 THEN GOSUB 5510 
1 'introducir nuevo player solo si el flag 'partida recién terminada' está activo.
5110 IF flagfinpartida=1 THEN GOSUB 5190 
1 'ordenacion de la matriz por burbuja
5120 GOSUB 5580
1 'hacer criba si ha habido partida, para ver si existe algún humano fuera de la tabla
5130 IF flagfinpartida=1 THEN GOSUB 5280 
5140 ''
1 'mostrar datos matriz mTabla$ ordenada o no
5150 GOSUB 5430 
1 '5160 PRINT"Presiona una tecla para escribir otro jugador...":CALL &BB18:GOTO 5110
5165 flagfinpartida=0
5170 RETURN

1'*** MOSTRAR MARCO MENÚ - INTRODUCIR PLAYER **********************
5190 CLS:CALL pintarSprMarcomenus
5195 LOCATE 11,10: PRINT"Introduce tu nombre: "
5200 LOCATE 11,12: INPUT nom$
5210 IF INSTR(nom$,"!")<>0 THEN posi=INSTR(nom$,"!"):MID$(nom$,posi,1)=" "
5220 IF nom$="" THEN nom$=" "
1'grabar en matriz el nuevo registro, buscando uno vacío 
5230 nom$=LEFT$(nom$,12)
5240 FOR k=1 TO 16
5250 IF mTabla$(k,1)="0" THEN mTabla$(k,1)=right$(str$(contador),2):mTabla$(k,0)=nom$:GOTO 5270
5260 NEXT k
5270 RETURN

1' ********** HACER CRIBA HASTA ENTRAR EN PUESTOS <= 8 ************
5280 ' 
5290 conthumano=0
1 'buscar humanos empezando por arriba
5300 FOR k=16 TO 1 STEP -1
5310 'si el item tiene nombre AND no tiene ! THEN es Humano
5320 IF LEN(mTabla$(k,0))>0 AND INSTR(mTabla$(k,0),"!")=0 THEN conthumano=conthumano+1:posi=k
5330 NEXT k
1 'PRINT"Conthumano=";conthumano;"   ";"posi(16-1)=";posi:PRINT
5340 dif=9-posi:conthumano=dif
1 '---Borrar admiraciones para subir humanos ----
1 ' '(9-16) si el ultimo esta en zona alta no borro
5350 IF posi>=9 THEN 5400
5360 FOR k=posi TO 16
1 'empezando por abajo, si item tiene nombre con "!" THEN borrarlo
5370 IF INSTR(mTabla$(k,0),"!")<>0 THEN mTabla$(k,0)="":mTabla$(k,1)="0":conthumano=conthumano-1
5380 IF conthumano=0 THEN 5400
5390 NEXT k 
1 'ordenar de nuevo
5400 GOSUB 5580 
5410 RETURN


1 ' *** MOSTRAR RESULTADO TABLA PUNTUACIÓN *********************
5430 CLS:conta=0:linea=0:CALL pintarSprMarcomenus 
1 'Activar Música si el flag está puesto y no se está reproduciendo  
5432 IF flagMusic=1 AND flagPlayMusic=0 THEN GOSUB 10900
5435 t1!=TIME 
5440 LOCATE 14,5:PRINT "HI-SCORE-TABLE"
5445 LOCATE 14,6:PRINT "--------------"
5450 FOR k=16 TO 9 STEP -1
5460 conta=conta+1:linea=linea+2:lon=12 -len(mTabla$(k,0)):puntos$=STRING$(lon,".")
5470 LOCATE 11,linea+6:PRINT STR$(conta);".";" ";:PRINT mTabla$(k,0);" ";puntos$;mTabla$(k,1)
5480 NEXT k
5485 a$=INKEY$
5487 t2!=TIME:totalTime=(t2!-t1!)/300:IF totalTime>25 THEN 5500
5489 IF a$="" THEN 5485
5500 RETURN

1 ' *** LOAD DATAs Wonderfuls ******************************
5510 flagdatas=1:RESTORE 5720
5530 DIM mTabla$(16,1):DIM temp$(1,1)
5540 FOR i=1 TO n
5550 READ mTabla$(i,0),mTabla$(i,1)
5560 NEXT i
5570 RETURN

1 ' *** ORDENACIÓN BURBUJA ****************************
5580 FOR i=1 TO n
5620 ord=0
5630 FOR j=1 TO n-i
5640 IF VAL(mTabla$(j,1))>VAL(mTabla$(j+1,1)) THEN temp$(1,0)=mTabla$(j,0):temp$(1,1)=mTabla$(j,1):mTabla$(j,0)=mTabla$(j+1,0):mTabla$(j,1)=mTabla$(j+1,1):mTabla$(j+1,0)=temp$(1,0):mTabla$(j+1,1)=temp$(1,1):ord=1
5650 NEXT j
5670 IF ord=0 THEN i=n
5680 NEXT i
5690 RETURN

1 ' **************************** DATAs ************************************
5710 '
5720 DATA WONDERFUL !,24,,0,,0,QUITE GOOD !,14,FINE !,10,,0,STUPENDOUS !,20,AMAZING !,28,,0,GOOD !,8,,0,,0,EXCELLENT !,18,,0,VERY GOOD !,16,THE KING !,31



1 '****************************************************************** 
1 ' (POKES) EN PRUEBAS: MOSTRARME EL COLOR QUE TOCA DE LA SECUENCIA 
1 '******************************************************************
1' 6000 'Pintar color
1' 6010 IF compsec(p)=1 THEN color=2
1' 6020 IF compsec(p)=2 THEN color=14
1' 6030 IF compsec(p)=3 THEN color=12
1' 6040 IF compsec(p)=4 THEN color=5
1' 6050 LOCATE 1,1:PEN color:PRINT CHR$(143)
1' 6060 RETURN



1 '******************************************** 
1 '     ENCENDIDO DE TECLAS-COLOR Y SONIDO 
1 '********************************************
1 'Azul
1 '|TINTA,3,11 :'previamente usaba el azul 2
7000 INK 2,11:INK 8,20
7010 SOUND 1,157,50,15
7020 RETURN

1 'Amarillo
1 '|TINTA,2,24
7100 INK 14,25:INK 11,24
7110 SOUND 1,135,50,15
7140 RETURN

1 'Verde  INK 3,9
7200 INK 6,18:INK 9,21:INK 12,22 
7210 SOUND 1,220,50,15
7240 RETURN

1 'Rojo INK 2,3
7300 INK 3,6
7310 SOUND 1,270,50,15
7340 RETURN


1 '************ PARPADEOS-INTERMITENCIAS de botón encendido/apagado **************
1 ' Azul
7400 INK 2,11,2:INK 8,20,14:RETURN
1 ' Amarillo
7410 INK 14,25,24:INK 11,24,15:RETURN
1 ' Verde
7420 INK 6,18,9:INK 9,18,12:INK 12,22,18:RETURN
1 ' Rojo
7430 INK 3,6,3:RETURN


1 ''***************** GANASTE ***********************'
1 'sub retardo 0.5"
7500 GOSUB 9000 
1 'Activar 5 sonidos agudos e iluminaciones 
7520 FOR v=1 TO 5
7530 ON playersec(p) GOSUB 7000,7100,7200,7300
7540 ENT 1,100,-5,1
7550 SOUND 1,142,30,15,,1
7560 NEXT v
1' Imprimir 7621  _pintar_spr_youwin
7570 CALL pintarSprYouwin
7580 |FLUSH,0
1 'Iluminar todas las teclas con intermitencias
7585 GOSUB 7400:GOSUB 7410:GOSUB 7420:GOSUB 7430
7590 CALL &BB18

1 ' _pintar_spr_nextlevel
7600 CALL pintarSprNextLevel 
7605 flagnext=0
7610 CALL &BB18
1 'Si pulso L o CTRL+L
7620 IF INKEY(36)=0 OR INKEY(36)=128 THEN flagnext=1
1 'subir de nivel
7630 IF nivel=8 THEN nivel=14:GOTO 7670
7640 IF nivel=14 THEN nivel=20:GOTO 7670
7650 IF nivel=20 THEN nivel=31:GOTO 7670
7660 IF nivel=31 THEN nivel=99
7670 RETURN


1 '****************************************
1 '*               MENU                   
1 '****************************************
8000 a$="":a=0:nivel=8:nivelj=1:modoj=1:flagRotacion=0
8010 controlkey$="Keyboard":controljoy$="Joystick"
8020 musicon$="ON ":musicoff$="OFF"
8030 IF controlflag=0 THEN control$=controlkey$ ELSE control$=controljoy$
1 'Fondo negro, letras blanco-gris PALETTE=0 1 2 11
1 ' 8040 MODE 1:BORDER 0:INK 0,0:INK 1,1:INK 2,2:INK 3,11:PEN 3
8040 MODE 1:BORDER 0:INK 0,0:INK 1,3:INK 2,15:INK 3,25:PEN 2
8050 CALL pintarSprMarcomenus
8060 IF flagMusic=1 THEN onoff$=musicon$ ELSE onoff$=musicoff$
8070 IF flagMusic=1 AND flagPlayMusic=0 THEN GOSUB 10900
1 'Menú
8160 LOCATE 11,6:PRINT"1. Level:";nivelj 
8170 LOCATE 11,8:PRINT"2. Mode:";modoj
8180 LOCATE 11,10:PRINT"3. Redefine Keys"
8190 LOCATE 11,12:PRINT"4. Control: "; control$ 
8200 LOCATE 11,14:PRINT"5. Hi-Score Table"
8210 LOCATE 11,16:PRINT"6. Demo"
8220 LOCATE 11,18:PRINT"7. Credits"
8230 LOCATE 11,20:PRINT"8. Play"
8235 LOCATE 11,22:PRINT"9. Music ";onoff$
8238 t1!=TIME 
1 'flagtablapunt: flag=1 indica que la Tabla de Puntuaciones ha sido cargada en la matriz, ordenada (inicializada)
8240 a$=INKEY$:IF flagtablapunt=0 THEN GOSUB 4000
1 'Si se superan 20" sin pulsar tecla, que lo gestione el Main
8242 t2!=TIME:totalTime=(t2!-t1!)/300:IF totalTime>20 THEN flagRotacion=1:GOTO 8390
8245 IF a$="" THEN 8240
8250 a=VAL(a$):flagRotacion=0
8260 IF a<1 OR a>9 THEN 8240

8270 IF a=1 THEN nivelj=nivelj+1:GOSUB 8400:GOTO 8160
8280 IF a=2 THEN modoj=modoj+1:GOSUB 8500:GOTO 8170
1 ' Redefinir teclado
8290 IF a=3 THEN GOSUB 10300:GOTO 8000
8300 IF a=4 AND controlflag=0 THEN controlflag=1:control$=controljoy$:GOSUB 10700:GOTO 8190
8310 IF a=4 AND controlflag=1 THEN controlflag=0:control$=controlkey$:GOSUB 10600:GOTO 8190
8320 IF a=5 THEN GOSUB 5000:GOTO 8000
8330 IF a=6 THEN GOSUB 3000:GOTO 8000
8340 IF a=7 THEN GOSUB 3500:GOTO 8000
8350 IF a=8 THEN GOSUB 10970:flagRotacion=0:GOTO 8390
1 'Activar música
8360 IF a=9 AND flagMusic=0 THEN flagMusic=1:onoff$=musicon$:GOSUB 10900:GOTO 8235 
1 ' Stop música
8370 IF a=9 AND flagMusic=1 THEN flagMusic=0:onoff$=musicoff$:GOSUB 10970:GOTO 8235
8390 RETURN

1 'Sub Nivel de juego
8400 IF nivelj>4 THEN nivelj=1:nivel=8
8410 IF nivelj=1 THEN nivel=8
8420 IF nivelj=2 THEN nivel=14
8430 IF nivelj=3 THEN nivel=20
8440 IF nivelj=4 THEN nivel=31
8450 RETURN

1 'Sub Modo de juego
8500 IF modoj>3 then modoj=1
8510 RETURN




1 '*********** Retardo 0.500 mseg **************
1 'flagtemp a 1 indica que el temporizador 0 del After ya cumplió su tiempo, se disparó y lo activó.
1 ''Retardo para sonido y luz boton
9000 flagtemp=1
9020 AFTER 25,0 GOSUB 9040
9030 GOSUB 1400
1 'pararse aqui para poder salir por el return
9035 IF flagtemp=1 THEN 9035 ELSE GOTO 9050 
9040 flagtemp=0: RETURN
9050 RETURN

1 ' *********** Retardo 0.180 mseg **************
1 ' Retardo entre botones para Juega Computer
1 'flagtemp se desactiva al completar el After'
9100 flagtemp=1
9110 AFTER 9,0 GOSUB 9130
9120 IF flagtemp=1 THEN 9120 ELSE GOTO 9140
1 'salida del after
9130 flagtemp=0: RETURN
1 'salida sub de retardo
9140 RETURN 


1 '********** CANCELAR SONIDO EN CURSO, RESTAURAR TINTAS (activado por After)***************
1 'borra o cancela canal 1, tono grave de 2k y tiempo 0,01s
9300 SOUND 129,2000,1:|FLUSH,1
1 'INK 2,3: INK 3,9: 'Restaurar tintas superiores
9310 INK 0,0:INK 1,1:INK 2,2:INK 3,3:INK 4,4:INK 5,6
9315 INK 6,9:INK 7,10:INK 8,11:INK 9,12:INK 10,13:INK 11,15
9320 INK 12,18:INK 13,22:INK 14,24:INK 15,26
1 'temporizador terminado y apagado
9330 flagtemp=0 
9340 GOSUB 1400
9380 RETURN


1 '******* Imprimir secuencia de números actual del Contador en turno del CPC
9500 tempcont$=RIGHT$(STR$(contador),2)
1 '74EF Imprimir _pintar_spr_display (Rótulo CPC + 2 dígitos apagado)
9510 CALL pintarSprDisplay
9520 IF (LEN(tempcont$)>1) THEN decena$=LEFT$(tempcont$,1)
9530 unidad$=RIGHT$(tempcont$,1)
1 'Imprimir ambos dígitos según el valor del contador
9540 POSIC%=0:DIG%=INT(VAL(unidad$)):CALL pintarSprNumDisplay,@POSIC%,@DIG% 
9550 POSIC%=1:DIG%=INT(VAL(decena$)):CALL pintarSprNumDisplay,@POSIC%,@DIG%
9560 RETURN


1 'REINICIALIZAR VARIABLES
10100 nivel=0:a=0:a$="":x=0:contador=0:temp=0:flagplayer=0:flagerror=0
10110 flaglev=0:flagtemp=0:p=0:flagstop=0
10120 ERASE compsec,playersec:DIM compsec(120):DIM playersec(120) 
10130 RETURN



1 ' ***************************** REDEFINICIÓN DEL TECLADO ******************************

1 'REDEFINIR TECLADO, la R y la L se permiten, pero avisar que Repeat será CTRL + R y Longest será CTRL + L 
10300 POKE teclaPulsada,128:POKE teclaRedef,1:CLS:li=10 
10303 LOCATE 13,li:PRINT"Choose Up/Red   ";:GOSUB 10500 

10307 POKE teclaPulsada,128:POKE teclaRedef,2
10310 LOCATE 13,li+2:PRINT"Choose Down/Blue   ";:GOSUB 10500 

10315 POKE teclaPulsada,128:POKE teclaRedef,4
10320 LOCATE 13,li+4:PRINT"Choose Left/Green   ";:GOSUB 10500 

10325 POKE teclaPulsada,128:POKE teclaRedef,3
10330 LOCATE 13,li+6:PRINT"Choose Right/Yellow   ";:GOSUB 10500
10335 GOSUB 10800:GOSUB 10430:flagRedefTeclado=1
10337 fkcu=peek(FKCup):fkcd=peek(FKCdw):fkcl=peek(FKCiz):fkcr=peek(FKCder)
10338 RETURN  


1 'Pokear - Grabar en memoria High y Low Byte Cte. ASM de cada tecla y como 3er byte su FKC
10340 tophb=VAL("&"+LEFT$(top$,2)):toplb=VAL("&"+RIGHT$(top$,2))
10350 POKE TeclaArribaHb,toplb:POKE TeclaArribaLb,tophb:POKE FKCup,fkcu 
10360 downhb=VAL("&"+LEFT$(down$,2)):downlb=VAL("&"+RIGHT$(down$,2))
10370 POKE TeclaAbajoHb,downlb:POKE TeclaAbajoLb,downhb:POKE FKCdw,fkcd
10380 izqhb=VAL("&"+LEFT$(izq$,2)):izqlb=VAL("&"+RIGHT$(izq$,2)) 
10390 POKE TeclaIzqHb,izqlb:POKE TeclaIzqLb,izqhb:POKE FKCiz,fkcl
10400 derhb=VAL("&"+LEFT$(der$,2)):derlb=VAL("&"+RIGHT$(der$,2))
10410 POKE TeclaDerHb,derlb:POKE TeclaDerLb,derhb:POKE FKCder,fkcr 
1 'Pokear teclas R y L (rep$/fkcrep y more$/fkcmore) 
10430 rephb=VAL("&"+LEFT$(rep$,2)):replb=VAL("&"+RIGHT$(rep$,2))
10440 POKE TeclaRepHb,replb:POKE TeclaRepLb,rephb:POKE FKCTecRepe,fkcrep
10450 morehb=VAL("&"+LEFT$(more$,2)):morelb=VAL("&"+RIGHT$(more$,2))
10460 POKE TeclaMoreHb,morelb:POKE TeclaMoreLb,morehb:POKE FKCTecMore,fkcmore
10470 CALL extraerFKCs
10490 RETURN
 
10500 CALL leerTeclaRedef
10510 IF PEEK(teclaPulsada)=128 THEN 10500
10520 PRINT CHR$(PEEK(teclaPulChar))
10530 FOR r=1 TO 300:NEXT 
10540 RETURN 

1 ' ACTIVAR-Redefinir CURSORES POR DEFECTO Sin redefinir tecla, llamada desde el Menú 
1 'Cursor arriba
10600 top$="0100":fkcu=0
1 'Cursor abajo
10610 down$="0400":fkcd=2 
1 'Cursor izquierda
10620 izq$="0101":fkcl=8
1 'Cursor derecha
10630 der$="0200":fkcr=1
1 'Teclas R y L'
10640 GOSUB 10800
1 'Pokear
10650 GOSUB 10340
10660 RETURN

1 ' ACTIVAR JOYSTICK
1 'Joystick arriba
10700 top$="0109":fkcu=72
1 'Joystick abajo
10710 down$="0209":fkcd=73 
1 'Joystick izquierda
10720 izq$="0409":fkcl=74
1 'Joystick derecha
10730 der$="0809":fkcr=75
1 'Teclas R y L'
10740 GOSUB 10800
1 'Pokear
10750 GOSUB 10340
10770 RETURN

1 'ASIGNAR A TECLAS R, L sus datos de constantes ASM de teclado y FKC
1 'Tecla R de Repetir secuencia anterior
10800 rep$="0406":fkcrep=50
1 'Tecla L de Longest o More o Más puntos y seguir jugando, aunque haya ganado el nivel en curso.
10810 more$="1004":fkcmore=36
10830 RETURN



1 ' ************************************************ 
1 '                   MUSICA 
1 ' ************************************************
1 'Inicialización de la canción a 0 (REBOBINADO)
10900 CALL InitMusic:flagInitMusic=1
10910 EVERY 1,3 GOSUB 10940
10920 RETURN

1 'Play 
10940 CALL PlayMusic:flagPlayMusic=1
10950 RETURN

1 'Stop / Pause
10970 CALL StopMusic
10980 temp=REMAIN(3):flagPlayMusic=0
10985 |FLUSH,1
10990 RETURN
