;org 0x8000
; *******************************************************************
; * AMPLIACIÓN DEL BASIC DEL 464 A ALGUNOS COMANDOS 6128            
; * Microhobby Amstrad Semanal 010 				    *
; NUEVOS COMANDOS RSX PARA BASIC:
; |RESET = Sin parámetros. Resetea CPC pero retiene el programa Basic si hay. 
; |SETCLOCK [,bajo [,alto]] = Inicializa reloj a 0 si no hay parámetros. Lo pone a 
; bajo si solo hay 1 param. <65536. Lo pone a bajo+65536 si hay 2 parámetros.
; |GPEN opción, color = Asigna la pluma para gráficos y la opción de ploteado.
; |GPAPER = asigna el color del papel de gráficos.
; |GET,@var-entera% = Espera a que se pulse una tecla y guarda su código ASCII en var.
; |FLUSH, buffer = Vacía el bufer de sonido is el param. es = 1. VAcía el de teclado si =9.
; |FILL,x,y,color = Llena de color una figura. El origen debe estar en 0,0
; * Si Empieza en &8000, ocupa hasta &81C6, Long=&1C6=454bytes
; *******************************************************************
.include "macros.h.s" ;macros para las instrucciones que faltan
_RSX6128::

ld bc,#_TablaRSX ;BC contiene la dirección de la Tabla de Comandos RSX
ld hl,#_EspacioTrabajo ;HL contiene la dir de los 4 bytes uso exclusivos del firm
jp 0xbcd1 ;KL LOG EXT = Inicia sesion de un (o varios) nuevo comando RSX en el firmware.

_TablaRSX:
cpl
add b
jp l80e6 ;comando |RESET
jp l80a1 ;comando |SETCLOCK
jp l80c6 ;comando |GPEN
jp l80dc ;comando |GPAPER
jp GET:: ;comando |GET
jp FLUSH:: ;comando |FLUSH
jp FILL:: ;comando |FILL
nop         ;espacio para meter los saltos a mis propios comandos
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
ld d,d      ;estos bytes son códigos ascii de los comandos
ld b,l
ld d,e
ld b,l
call nc,0x4553
ld d,h
ld b,e
ld c,h
ld c,a
ld b,e
bit 0,a
ld d,b
ld b,l
adc #0x47
ld d,b
ld b,c
ld d,b
ld b,l
jp nc,0x4547
call nc,0x4c46
ld d,l
ld d,e
ret z
ld b,(hl)
ld c,c
ld c,h
call z,0x0000
nop             ;espacio para meter los nombres de los comandos 
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop

_EspacioTrabajo:
nop
nop
nop
nop

_GestionError:
ld hl,#l8095
.l808c
ld a,(hl)
call 0xbb5a ;TXT OUTPUT: muestra ascii (00-1F) en pantalla
inc hl
and a
jr nz,l808c
ret

.l8095
ld d,d
ld d,e
ld e,b
jr nz,#l80ff
ld (hl),d
ld (hl),d
ld l,a
ld (hl),d
dec c
ld a,(bc)
nop
.l80a1
ld hl,#0x0000
ld de,#0x0000
and a
jp z,0xbd10
dec a
jr nz,l80b7
ld__l_ix_mas_n #0x00 ;ld l,(ix+#0x00) 
ld__h_ix_mas_n #0x01 ;ld h,(ix+#0x01)
jp 0xbd10

.l80b7
ld__e_ix_mas_n #0x00 ;ld e,(ix+#0x00)
ld__d_ix_mas_n #0x01;ld d,(ix+#0x01)
ld__l_ix_mas_n #0x02 ;ld l,(ix+#0x02)
ld__h_ix_mas_n #0x03 ;ld h,(ix+#0x03)
jp 0xbd10

.l80c6
cp #0x02
jp nz,_GestionError
ld__a_ix_mas_n #0x00 ;ld a,(ix+#0x00)
call 0xbbde
ld a,#0x17
call 0xbb5a
ld__a_ix_mas_n #0x02;ld a,(ix+#0x02)
jp 0xbb5a

.l80dc
dec a
jp nz,_GestionError
ld__a_ix_mas_n #0x00 ;ld a,(ix+#0x00)
jp 0xbbe4

.l80e6
call 0xb906
push af
call 0xbd37
call 0xbb00
call 0xbbff
call 0xbc65
call 0xbca7
call 0xbb5a
call 0xbb4e
.l80ff
pop af
jp 0xb90c

GET::
dec a
jp nz,_GestionError
call 0xbb06 ;KM WAIT CHAR: Espera pulsación de carácter y guarda en A. Flag Carry=1.
ld__l_ix_mas_n #0x00 ;ld l,(ix+#0x00)
ld__h_ix_mas_n #0x01 ;ld h,(ix+#0x01)
ld (hl),a
inc hl
ld (hl),#0x00
ret

FLUSH::
dec a ;Reg A almacena el nº de parámetros del comando
jp nz,_GestionError ;Saltar a error si hay más de 1 parámetro
ld__a_ix_mas_n #0x00 ;ld a,(ix+#0x00) ;Obtener parámetro y cargarlo en A
and a
jp nz,0xbca7 ;SOUND RESET
_BorraBufer:
call 0xbb09 ;KM READ CHAR: comprueba Bufer si un carácter está disponible y lo guarda en A. Flag C=1
jr c,_BorraBufer ;Si flag C=1, volver a comprobar bufer, hasta borrarlos todos.
ret

FILL::
cp 0x03
jp nz,_GestionError
ld__a_ix_mas_n #00 ;ld a,(ix+#0x00)
call 0xbbde
ld__l_ix_mas_n #02 ;ld l,(ix+#0x02)
ld__h_ix_mas_n #03 ;ld h,(ix+#0x03)
ld__e_ix_mas_n #04 ;ld e,(ix+#0x04)
ld__d_ix_mas_n #05 ;ld d,(ix+#0x05)
push de
ld (0x81c7),de
ld (0x81c9),hl
call 0xbbf0
ld (0x81cb),a
inc a
call 0xbbe4
call 0xbc11
ld a,#0x04
jr c,l815c
ld a,#0x02
jr z,l815c
ld a,#0x01
.l815c
ld (0x81cc),a
.l815f
call l8195
sbc hl,bc
call l8178
jr z,l815f
pop de
ld (0x81c7),de
.l816e
call l8195
add hl,bc
call l8178
jr z,l816e
ret

.l8178
ld (0x81c7),hl
ex de,hl
ld hl,(0x81c9)
call 0xbbf0
ld hl,#0x81cb
cp (hl)
ret

.l8187
ld de,(0x81c7)
push hl
call 0xbbf0
ld hl,#0x81cb
cp (hl)
pop hl
ret

.l8195
ld hl,(0x81c9)
.l8198
inc hl
inc hl
call l8187
jr z,l8198
dec hl
dec hl
push hl
ld hl,(0x81c9)
.l81a5
dec hl
dec hl
call l8187
jr z,l81a5
inc hl
inc hl
ld de,(0x81c7)
call 0xbbc0
pop hl
ld de,(0x81c7)
call 0xbbf6
ld hl,(0x81c7)
xor a
ld bc,(0x81cc)
ld b,a
ret
