;org #8015
; *******************************************************************
; * MODE 1 DOBLE NUMERO DE COLORES 				    *
; * Microhobby Amstrad Semanal 099 				    *
; NUEVOS COMANDOS RSX PARA BASIC:
; |ON,x = Activa IRQ para la zona de pantalla elegida (0-3) 
; |OFF = Desactiva IRQs pasando pantalla a modo normal 4 colores
; |TINTA,x,y = Cambia colores de las tintas adicionales, como INK
; |BORDE, x = Cambia color del borde para la zona de pantalla elegida
; * Si Empieza en &8000, ocupa hasta &8148, Long=&148=328bytes
; *******************************************************************
.include "macros.h.s" ;macros para las instrucciones que faltan

_RSX::

;; *********************** Configuración RSX ****************************
ld bc,#_TablaRSX
ld hl,#_EspacioTrabajo
jp 0xbcd1 ;KL LOG EXT = Inicia sesion de un (o varios) nuevo comando RSX en el firmware.
         ;BC contiene la dirección de la Tabla de Comandos RSX
         ;HL contiene la dir de los 4 bytes uso exclusivos del firm

_TablaRSX::  ;Tabla de saltos a las rutinas de los comandos RSX
.dw _TablaNombres  ;Define Word: almacena constante valor bin de la expr en palabra de 16bits
                     ;Este es el Puntero de 2 bytes a la lista de nombres

jp GRASETPEN ;comando |GRSETPEN, para asignar color de pluma gráfica 

jp FLUSH ;comando |FLUSH, para vaciado de buferes de teclado o sonido

_TablaNombres:: ;Nombres de los comandos RSX 
.ascii "GRSETPE"    ;sustituyo el DEFM 
.db "N"+#0x80       ;generar bytes sucesivos de datos binarios 

.ascii "FLUS"   ;comando extra para vaciado de buferes de teclado o sonido
.db "H"+#0x80
.db 0

_EspacioTrabajo::
.ds 4   ;Reservar N bloques de espacio de bytes, 4 para el firm



;;************** RUTINA Sets the graphics PEN. **********************************
GRASETPEN::
ld__a_ix_mas_n #0x00 ;ld a,(ix+#0x00) ;Obtener parámetro y cargarlo en A
call 0xBBDE
ret 


;;************** RUTINA FLUSH DE VACIADO DE BUFERES TECLADO Y SONIDO ************
FLUSH::
dec a ;Reg A almacena el nº de parámetros del comando
jp nz,_GestionError ;Saltar a error si hay más de 1 parámetro
ld__a_ix_mas_n #0x00 ;ld a,(ix+#0x00) ;Obtener parámetro y cargarlo en A
and a ;comprobar si el parámetro es 0 o 1 activando el flag Z
jp nz,0xbca7 ;SOUND RESET si param vale 1
_BorraBufer:
call 0xbb09 ;Si param=0 KM READ CHAR: comprueba Bufer si un carácter está disponible (y se borra?) y lo guarda en A. Flag C=1
jr c,_BorraBufer ;Si flag C=1, volver a comprobar bufer, hasta borrar todos los caracteres que hubiera.
ret

_GestionError:
ld hl,#_TxtError
_Imprimir:
ld a,(hl)
call 0xbb5a ;TXT OUTPUT: muestra ascii (00-1F) en pantalla
inc hl
and a
jr nz,_Imprimir
ret
_TxtError:
.asciz "RSX Error"

ret ;a mi etiqueta _RSX:: llamada desde el _main::